function getContent(mode) {
	var html = content.innerHTML;
	// TinyMCE getContent made setContent not to work (innerHTML or TinyMCE)
	//var html = tinymce.activeEditor.getContent();
	html = html.replace(/ data-mce-[^z][a-z0-9\-]*="[^"]*"/g,"");
	html = html.replace(/&nbsp;/g," ");
	html = html.replace(/<p( [^>]+)?>(<ol>|<ul>)|(<\/ol>|<\/ul>)<\/p>/g,"$2$3");
	mysword.getContent(html, fontcss, mode);
}
function execCommand(command,param) {
	document.execCommand(command,false,param);
	tinymce.activeEditor.undoManager.add();
	if (splitView) rememberCursor();
}
function applyFormat(format,param) {
	tinymce.activeEditor.formatter.apply(format,param);
	tinymce.activeEditor.undoManager.add();
	if (splitView) rememberCursor();
}
function removeFormat() {
	tinymce.activeEditor.formatter.remove('removeformat');
	tinymce.activeEditor.undoManager.add();
	if (splitView) rememberCursor();
}
function setFont(font,css) {
	if (css.length == 0) {
		var el = tinymce.activeEditor.selection.getNode();
		if (el) {
			var name = el.style.fontFamily;
			tinymce.activeEditor.formatter.remove('fontname',{value:name});
			tinymce.activeEditor.undoManager.add();
			if (splitView) rememberCursor();
		}
	} else {
		if (fontcss.indexOf(css) == -1) {
			fontcss += css;
			fontstyle.innerHTML=fontcss;
		}
		applyFormat('fontname',{value: font});
	}
}
function deleteLine() {
	var sel = window.getSelection();
	if (sel.rangeCount)
		range = sel.getRangeAt(0).cloneRange();
	if (!range) return;
	var el=range.startContainer;
	if (el.nodeType==3)
		el=el.parentNode;
	do {
		var n = el.tagName;
		if (n=='P' || n=='H1' || n=='H2' || n=='H3' || n=='H4' || n=='H5' || n=='H6' || n=='LI' || n=='TR' || n=='BLOCKQUOTE')
			break;
		el=el.parentNode;
	} while (el);
	if (el) {
		var brs = el.getElementsByTagName('BR');
		var wbr = brs.length > 0;
		if (brs.length == 1 && el.firstChild.nodeName == 'BR' && el.firstChild == el.lastChild)
			wbr = false;	// empty paragraph?
		if (wbr) {
			var s = range.startContainer;
			while (s && s.nodeName != 'BR') {	// locate left BR
				if (s.previousSibling)
					s = s.previousSibling;
				else
					s = s.parentNode;
				if (s == el) {
					s = el.firstChild;
					break;
				}
			}
			var e = range.startContainer;
			while (e && e.nodeName != 'BR') {	// locate right BR
				if (e.nextSibling)
					e = e.nextSibling;
				else
					e = e.parentNode;
				if (e == el) {
					e = el.lastChild;
					break;
				}
			}
			if (s.nodeName == 'BR' && e.nodeName == 'BR')
				s = s.nextSibling;
			var hook = e.nextSibling;
			if (!hook) {
				hook = s;
				if (s.nodeName == 'BR')
					hook = s.previousSibling;
			}
			var ed = tinymce.activeEditor;
			while (true) {
				var n = s.nextSibling;
				ed.dom.remove(s);
				s = n;
				if (s == e) {
					ed.dom.remove(s);
					break;
				}
			}
			if (hook) {
				ed.selection.select(hook);
				ed.selection.collapse();
			}
			ed.undoManager.add();
			if (splitView) rememberCursor();
			return;
		}
		var ed = tinymce.activeEditor;
		var hook = el.nextSibling;
		var first = true;
		if (!hook) {
			hook = el.previousSibling;
			if (hook)
				first = false;
		}
		if (!hook) {
			hook = el.parentNode;
			if (hook && (hook.nodeName == 'UL' || hook.nodeName == 'OL' || hook.nodeName == 'TBODY')) {
				if (hook.previousSibling)
					hook = hook.previousSibling;
				else if (hook.nextSibling)
					hook = hook.nextSibling;
				else
					hook = hook.parentNode;
			}
		}
		ed.dom.remove(el);
		if (hook) {
			//ed.selection.select(hook);	// makes it jumpy: goes to next of next sibling
			//ed.selection.collapse();
			var r = document.createRange();
			if (first)
				hook = hook.firstChild;
			else
				hook = hook.lastChild;
			r.setStart(hook,0);
			r.setEnd(hook,0);
			var sel = window.getSelection();
			sel.removeAllRanges();
			sel.addRange(r);
		}
		/*var r = document.createRange();
		r.selectNode(el);
		var sel = window.getSelection();
		sel.removeAllRanges();
		sel.addRange(r);
		execCommand('delete');*/
		ed.undoManager.add();
		if (splitView) rememberCursor();
	}
}
function setContent(text) {
	//content.innerHTML=text;
	var ed=tinymce.activeEditor;
	var bm=ed.selection.getBookmark(2,true);
	ed.setContent(text);
	ed.focus();	// needed to show cursor
	ed.selection.moveToBookmark(bm);
	ed.undoManager.add();
}
function undo() {
	tinymce.activeEditor.undoManager.undo();
	if (typeof doneFind=='function') doneFind();
	if (splitView) rememberCursor();
}
function redo() {
	tinymce.activeEditor.undoManager.redo();
	if (typeof doneFind=='function') doneFind();
	if (splitView) rememberCursor();
}
function indent() {
	tinymce.activeEditor.execCommand('indent');
}
function outdent() {
	tinymce.activeEditor.execCommand('outdent');
}
function selectAll() {
	var ed = tinymce.activeEditor;
	ed.selection.select(ed.getBody(), true);
}
function copy() {
	var sel = window.getSelection();
	if (sel.rangeCount)
		range = sel.getRangeAt(0).cloneRange();
	if (!range) return;
	if (range.isCollapsed) return;
	var div = document.createElement('div');
	div.appendChild( range.cloneContents().cloneNode(true) );
	var html = div.innerHTML;
	mysword.copy(html);
}
function cut() {
	var sel = window.getSelection();
	if (sel.rangeCount)
		range = sel.getRangeAt(0).cloneRange();
	if (!range) return;
	if (range.isCollapsed) return;
	var div = document.createElement('div');
	div.appendChild( range.cloneContents().cloneNode(true) );
	var html = div.innerHTML;
	execCommand('delete');
	mysword.copy(html);
}
function pageUp() {
	range = document.createRange();
	range.selectNodeContents(content);
	range.collapse(true);
	var sel = window.getSelection();
	sel.removeAllRanges();
	sel.addRange(range);
}
function pageDown() {
	range = document.createRange();
	range.selectNodeContents(content);
	range.collapse(false);
	var sel = window.getSelection();
	sel.removeAllRanges();
	sel.addRange(range);
}
function scrollDown() {
	var y;
	if (document.height)
		y = document.height-innerHeight;
	else
		y = content.clientHeight-innerHeight;
	if (y > 0)
		scrollTo(0,y)
}
function getFontSize() {
	var el = tinymce.activeEditor.selection.getNode();
	if (el)
		mysword.getFontSize(el.style.fontSize);
	else
		mysword.getFontSize('1em');
}
function getFont() {
	var el = tinymce.activeEditor.selection.getNode();
	if (el)
		mysword.getFont(el.style.fontFamily);
	else
		mysword.getFont('');
}
var list;
function getNumList() {
	var el = tinymce.activeEditor.selection.getNode();
	while (el) {
		var n = el.tagName;
		if (n=='OL')
			break;
		el=el.parentNode;
	}
	if (el) {
		list=el;
		mysword.getNumList(el.className);
	} else
		mysword.getNumList(null);
}
function changeNumList(style) {
	if (!list)
		return;
	if (style.length == 0) {
		list.removeAttribute('class');
	} else {
		list.setAttribute('class',style);
		// don't use tinymce as it wraps a span making the parent unreachable
		//tinymce.DOM.setAttrib(list,'class',style);
	}
	tinymce.activeEditor.undoManager.add();
	if (splitView) rememberCursor();
	list=null
}
function getStyle(parent) {
	var el = tinymce.activeEditor.selection.getNode();
	if (parent && el)
		el = el.parentNode;
	if (el)
		mysword.getStyle(el.getAttribute('style'),el.tagName,parent);
		//mysword.getStyle(tinymce.DOM.getAttrib(el,'style',''),el.tagName);
	else
		mysword.getStyle('','',parent);
}
function changeStyle(css,parent) {
	var el = tinymce.activeEditor.selection.getNode();
	if (parent && el)
		el = el.parentNode;
	if (el) {
		if (css.length == 0) {
			el.removeAttribute('style');
		} else {
			el.setAttribute('style',css);
			// don't use tinymce as it wraps a span making the parent unreachable
			//tinymce.DOM.setAttrib(el,'style',css);
		}
		tinymce.activeEditor.undoManager.add();
		if (splitView) rememberCursor();
	}
}
function getHTML(parent) {
	var el = tinymce.activeEditor.selection.getNode();
	if (parent && el)
		el = el.parentNode;
	if (el) {
		var html=el.innerHTML.replace(/ data-mce-[a-z0-9\-]+="[^"]*"/g,"");
		mysword.getHTML(html,el.tagName,parent);
	} else
		mysword.getHTML('','',parent);
}
function changeHTML(html,parent) {
	var el = tinymce.activeEditor.selection.getNode();
	if (parent && el)
		el = el.parentNode;
	if (el) {
		rememberCursor();
		el.innerHTML=html;
		tinymce.activeEditor.undoManager.add();
		restoreCursor();
		if (splitView) rememberCursor();
	}
}
function getLink() {
	var el = getLinkOnCursor(true);
	if (el)
		mysword.getLink(el.href);
}
function editLink() {
	var el = getLinkOnCursor(false);
	if (el) {
		range = document.createRange();
		range.selectNodeContents(el);
		var sel = window.getSelection();
		sel.removeAllRanges();
		sel.addRange(range);
		mysword.editLink(el.href, el.innerHTML);
	} else
		mysword.editLink(null, null);
}
function changeLink(link, text) {
	var el = tinymce.activeEditor.selection.getNode();
	if (el.nodeName == 'A') {
		el.href = link;
		el.innerHTML = text;
		tinymce.activeEditor.undoManager.add();
	} else {
		execCommand('insertHTML', "<a href='"+link+"'>"+text+"</a>");
	}
}
function miniLink() {
	var el = getLinkOnCursor(false);
	if (el) {
		mysword.miniLink(el.href, el.innerHTML);
	} else
		mysword.miniLink(null, null);
}
function getLinkOnCursor(goleft) {
	var sel = window.getSelection();
	if (sel.rangeCount)
		range = sel.getRangeAt(0).cloneRange();
	if (!range) return null;
	var el=range.startContainer;
	if (el.nodeType==3) el=el.parentNode;
	do {
		var n = el.tagName;
		if (n == 'A')
			break;
		el=el.parentNode;
	} while (el);
	if (!el && goleft) {
		el=range.startContainer;
		//mysword.log(el+"/"+el.tagName)
		while (el && el.tagName != 'A') {
			if (el.parentNode && el.parentNode.tagName == 'SPAN' && !el.previousSibling)
				el = el.parentNode;
			else
				el = el.previousSibling;
			//mysword.log(""+el)
			if (el && el.nodeType==1) {
				var ls = el.getElementsByTagName('A');
				if (ls.length > 0) {
					el = ls[ls.length-1];
					//mysword.log(el+"/"+el.href)
					break;
				}
			}
		}
	}
	return el;
}
function changeImage(source, style) {
	var el = tinymce.activeEditor.selection.getNode();
	el.src = source;
	el.setAttribute('style', style);
	tinymce.activeEditor.undoManager.add();
	if (splitView) rememberCursor();
}
function insertBreak() {
	tinymce.activeEditor.execCommand('mceInsertContent',true,"<br/>&zwnj;");
}
function insertParagraph() {
	tinymce.activeEditor.execCommand('mceInsertContent',true,"<p><br/></p>");
}
function insertBlockquote() {
	tinymce.activeEditor.execCommand('mceInsertContent',true,"<blockquote><br/></blockquote>");
}
function restorePosition() {
	// no need
}
function rememberPosition() {
	// no need
}
var content, range, blurRange, fontcss, fontstyle;
function onload() {
	content=document.getElementById('content');
	fontstyle=document.getElementById('fontcss');
	fontcss=fontstyle.innerHTML;
	// This will make Jelly bean selection without handles
	//document.designMode='on';
	document.execCommand('defaultParagraphSeparator',false,'p');
	scroll();
	content.focus();
	mysword.log('onload');
	if (splitView) {
		var change=function() {
			rememberCursor();
		};
		content.onselectstart = change;
		content.onkeyup = change;
		content.onmouseup = change;
		content.onfocus = function(e) {
			restoreCursor();
		};
	}
	getContent('onload');
}
function rememberCursor() {
	var sel = window.getSelection();
	if (sel.rangeCount) {
		blurRange = sel.getRangeAt(0);
	}
}
function restoreCursor() {
	if (blurRange) {
		var sel = window.getSelection();
		sel.removeAllRanges();
		sel.addRange(blurRange.cloneRange());
		mysword.log('restoreCursor');
		blurRange = null;
	}
}
function moveCursorToEnd() {
	var sel = tinymce.activeEditor.selection;
	if (sel.getNode()) {
		sel.collapse(true);
	}
}
function scroll(){
	var b=document.getElementById('backimg');
	var p=window.pageYOffset;var h=document.body.scrollHeight;
	if(p+b.offsetHeight>h)p=h-b.offsetHeight;
	b.style.top=p+'px';
}
function initSaveTimer() {
	setInterval(function(){
		if(mysword.getSaveQueue() == 'save')
			getContent('save');
	},10000);
}